# Use Auto DevOps pipeline
# https://gitlab.com/gitlab-org/gitlab/blob/master/lib/gitlab/ci/templates/Auto-DevOps.gitlab-ci.yml
include:
  - template: Auto-DevOps.gitlab-ci.yml

variables:
  # disable auto devops tests
  BROWSER_PERFORMANCE_DISABLED: 1
  CODE_INTELLIGENCE_DISABLED: 1
  CODE_QUALITY_DISABLED: 1
  CONTAINER_SCANNING_DISABLED: 1
  DAST_DISABLED: 1
  DEPENDENCY_SCANNING_DISABLED: 1
  SAST_DISABLED: 1
  LICENSE_MANAGEMENT_DISABLED: 1
  LOAD_PERFORMANCE_DISABLED: 1
  PERFORMANCE_DISABLED: 1
  SECRET_DETECTION_DISABLED: 1
  TEST_DISABLED: 1

  # configure auto devops components
  STAGING_ENABLED: 1

  # Agent
  KUBE_INGRESS_BASE_DOMAIN: dev.lincsproject.ca
  KUBE_CONTEXT: "calincs/gitlab-agents:dev-agent"
  KUBE_NAMESPACE: $CI_PROJECT_NAME-$CI_COMMIT_REF_SLUG # or $CI_ENVIRONMENT_SLUG

  # application variables
  K8S_SECRET_NEXTAUTH_URL: https://$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG.$KUBE_INGRESS_BASE_DOMAIN
  K8S_SECRET_NEXTAUTH_SECRET: $NEXTAUTH_SECRET
  K8S_SECRET_KEYCLOAK_ID: nextjs-template
  K8S_SECRET_KEYCLOAK_SECRET: $KEYCLOAK_SECRET
  K8S_SECRET_KEYCLOAK_ISSUER: https://keycloak.dev.lincsproject.ca/realms/lincs
  K8S_SECRET_LINCS_AUTH_API_URL: https://auth-api.dev.lincsproject.ca

cache:
  paths:
    - node_modules

staging:
  variables:
    KUBE_INGRESS_BASE_DOMAIN: stage.lincsproject.ca
    KUBE_CONTEXT: "calincs/gitlab-agents:stage-agent"
    KUBE_NAMESPACE: $CI_PROJECT_NAME-$CI_PROJECT_ID-staging
    K8S_SECRET_NEXTAUTH_URL: https://nextjs.$KUBE_INGRESS_BASE_DOMAIN
    K8S_SECRET_KEYCLOAK_ISSUER: https://keycloak.stage.lincsproject.ca/realms/lincs
    K8S_SECRET_LINCS_AUTH_API_URL: https://auth-api.stage.lincsproject.ca
  environment:
    name: staging
    url: $K8S_SECRET_NEXTAUTH_URL

production_manual:
  variables:
    KUBE_INGRESS_BASE_DOMAIN: lincsproject.ca
    KUBE_CONTEXT: "calincs/gitlab-agents:prod-agent"
    KUBE_NAMESPACE: $CI_PROJECT_NAME-$CI_PROJECT_ID-production
    K8S_SECRET_NEXTAUTH_URL: https://nextjs.$KUBE_INGRESS_BASE_DOMAIN
    K8S_SECRET_KEYCLOAK_ISSUER: https://keycloak.lincsproject.ca/realms/lincs
    K8S_SECRET_LINCS_AUTH_API_URL: https://auth-api.lincsproject.ca
  environment:
    name: production
    url: $K8S_SECRET_NEXTAUTH_URL

dev:
  extends: .auto-deploy
  stage: staging
  variables:
    K8S_SECRET_NEXTAUTH_URL: https://nextjs.$KUBE_INGRESS_BASE_DOMAIN
  script:
    - auto-deploy check_kube_domain
    - auto-deploy download_chart
    - auto-deploy use_kube_context || true
    - auto-deploy ensure_namespace
    - auto-deploy create_secret
    - auto-deploy deploy
  rules:
    - if: "$CI_DEPLOY_FREEZE"
      when: never
    - if: '($CI_KUBERNETES_ACTIVE == null || $CI_KUBERNETES_ACTIVE == "") && ($KUBECONFIG == null || $KUBECONFIG == "")'
      when: never
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH || $CI_COMMIT_TAG"
  environment:
    name: development
    url: $K8S_SECRET_NEXTAUTH_URL
